/*
 * dx2d.h
 *
 *  Created on: Jan 25, 2018
 *      Author: Hubert Vansteenhuyse
 */

#ifndef SRC_GUI_GRAPHICAL_DX2D_H_
#define SRC_GUI_GRAPHICAL_DX2D_H_

#ifdef __cplusplus
extern "C" {
#endif

#define DX2D_DLL_NAME				"dx2d.dll"

/*
 * structure to pass functionalities implemented in winmain.c to the dll.
 */
typedef struct iface_plat_dll{
	WCHAR* (*WC)(char *txt, WCHAR *out);
}iface_plat_dll;


#ifdef __cplusplus
	#include <windows.h>

	HRESULT WINAPI		dx2d_init			(iface_plat_dll *iface, int swDoubleBuffer);
	HRESULT WINAPI		dx2d_exit			(void);

	HRESULT WINAPI 		dx2d_render_start	(UINT32 w, UINT32 h, HWND hwnd);
	HRESULT WINAPI 		dx2d_render_end		(void);

	HRESULT WINAPI 		dx2d_color_pen		(float col_maxval, float r, float g, float b, float a);
	HRESULT WINAPI 		dx2d_color_brush	(float col_maxval, float r, float g, float b, float a);

	int		WINAPI		dx2d_fontw			(void);
	int		WINAPI		dx2d_fonth			(void);
	HRESULT	WINAPI		dx2d_usefont		(const char *name, int size, int swBold, int swItalic);
	void	WINAPI		dx2d_set_text		(int swBold, int swItalic, int swOpaque);
	void	WINAPI		dx2d_lentextw		(WCHAR *str, int n, int *w, int *h);
	void	WINAPI		dx2d_outtextw		(int x, int y, WCHAR *str, int n);

	void	WINAPI		dx2d_cls			(void);
	void 	WINAPI		dx2d_line			(int x1, int y1, int x2, int y2);
	void 	WINAPI		dx2d_dashline		(int x1, int y1, int x2, int y2);
	void 	WINAPI		dx2d_rectangle		(int swFilled, int x, int y, int wdt, int hgt);
	void 	WINAPI		dx2d_circle			(int swFilled, int x, int y, int r);
	void 	WINAPI		dx2d_polygon		(int swFilled, int elements, double *x, double *y);
	void 	WINAPI		dx2d_linepath		(int elements, double *x, double *y);

#endif

#ifdef __cplusplus
}
#endif

#endif /* SRC_GUI_GRAPHICAL_DX2D_H_ */
