/*
    Copyright (C) 2000, 2009 Vansteenhuyse Hubert <hubert.vansteenhuyse@freecode.be>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/
#include <stdio.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include "platform.h"
#define MAX_COL (SYSCOL_CYANL - SYSCOL_BLACK + 1)

//                     BLK   WHT   GRY   LGRY  RED   LRED  GRN   LGRN  BLU   LBLU  YELO  BRWN  MAG   LMAG  CYA   LCYA
double 	_r[MAX_COL] = {0.00, 1.00, 0.90, 0.95, 1.00, 1.00, 0.00, 0.60, 0.00, 0.70, 0.50, 1.00, 0.50, 1.00, 0.00, 0.00, },
		_g[MAX_COL] = {0.00, 1.00, 0.90, 0.95, 0.00, 0.25, 1.00, 1.00, 0.00, 0.70, 0.50, 1.00, 0.00, 0.00, 0.50, 1.00, },
		_b[MAX_COL] = {0.00, 1.00, 0.90, 0.95, 0.00, 0.25, 0.00, 0.60, 1.00, 1.00, 0.00, 0.00, 0.50, 1.00, 0.50, 1.00, };

void plat_normal_color(IPLAT icol, double *r, double *g, double *b, double *a){
	icol -= SYSCOL_BLACK;
	icol = CLAMP(icol, 0, MAX_COL - 1);
	*r = _r[icol];
	*g = _g[icol];
	*b = _b[icol];
	*a = 1;
}


PLAT_RECT plat_rect_grow(PLAT_RECT *a, PLAT_RECT *b){
	PLAT_RECT r;

	r.x = MIN(a->x, b->x); r.x = MIN(r.x, a->xx); r.x = MIN(r.x, b->xx);
	r.y = MIN(a->y, b->y); r.y = MIN(r.y, a->yy); r.y = MIN(r.y, b->yy);

	r.xx = MAX(a->x, b->x); r.xx = MAX(r.xx, a->xx); r.xx = MAX(r.xx, b->xx);
	r.yy = MAX(a->y, b->y); r.yy = MAX(r.yy, a->yy); r.yy = MAX(r.yy, b->yy);

	return r;
}

#define PLAT_LEN_UTF8(i) 				\
	( 	((i) < 0x80) ? 1 :				\
		(((i) & 0xE0) == 0xC0) ? 2 : 	\
		(((i) & 0xF0) == 0xE0) ? 3 : 	\
		(((i) & 0xF8) == 0xF0) ? 4 :	\
		0	)

int plat_utf8_valid(const unsigned char *str){
	int	cnt = 0, len;
	while(str && *str){
		//check the first char and get the length
		len = PLAT_LEN_UTF8(*str);
		if(len == 0){
			return 0;
		} else if(len > 1){
			//check the encoded sequence (bytes after the first char)
			for(int i = 1; i < len; i++){
				if((str[i] & 0x80) != 0x80)
					return 0;
			}
		}

		cnt++;
		str = str + len;
	}

	return str ? cnt : 0;
}


